package com.unipi.talepis.iatriki2022_3;

import org.springframework.web.bind.annotation.*;

import java.sql.*;
import java.util.HashMap;
import java.util.Map;

@RestController
public class DBController {
    private static String url = "jdbc:sqlite:src/main/resources/DB/iatriki2022covid.db";
    @RequestMapping("/allpatients")
    public String selectAllPatients(){
        String selectSQL = "SELECT * FROM CovidCase";
        StringBuilder stringBuilder = new StringBuilder();
        try {
            Connection connection = DriverManager.getConnection(url);
            Statement statement = connection.createStatement();
            ResultSet resultSet = statement.executeQuery(selectSQL);
            while (resultSet.next()){
                stringBuilder.append(resultSet.getString("PatientName"))
                        .append(",").append(resultSet.getString("Description"))
                        .append("<br/>");
            }
            statement.close();
            connection.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return stringBuilder.toString();
    }
    @GetMapping("/Case/{id}")
    public CovidCase getCase(@PathVariable Integer id){
        String selectSQL = "SELECT * FROM CovidCase WHERE ID=?";
        CovidCase covidCase = new CovidCase();
        try {
            Connection connection = DriverManager.getConnection(url);
            PreparedStatement preparedStatement = connection.prepareStatement(selectSQL);
            preparedStatement.setInt(1,id);
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()){
                covidCase.setId(resultSet.getInt("ID"));
                covidCase.setPatientName(resultSet.getString("PatientName"));
                covidCase.setDescription(resultSet.getString("Description"));
                covidCase.setGender(resultSet.getString("Gender"));
                covidCase.setHospital(resultSet.getString("Hospital"));
                covidCase.setAge(resultSet.getInt("Age"));
            }
            preparedStatement.close();
            connection.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return covidCase;
    }
    @PostMapping("/newCase")
    public Map<String,String> insertCase(@RequestBody Map<String,String> body){
        int id = Integer.parseInt(body.get("id"));
        String patientName = body.get("patientName");
        String description = body.get("description");
        String gender = body.get("gender");
        String hospital = body.get("hospital");
        int age = Integer.parseInt(body.get("age"));
        String insertSQL = "INSERT INTO CovidCase values(?,?,?,?,?,?)";
        String result = null;
        try {
            Connection connection = DriverManager.getConnection(url);
            PreparedStatement preparedStatement = connection.prepareStatement(insertSQL);
            preparedStatement.setInt(1,id);
            preparedStatement.setString(2,patientName);
            preparedStatement.setString(3,description);
            preparedStatement.setInt(4,age);
            preparedStatement.setString(5,hospital);
            preparedStatement.setString(6,gender);
            if(preparedStatement.executeUpdate()>0){
                result = "Success";
            }else {
                result = "Fail";
            }
            preparedStatement.close();
            connection.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Map<String,String> jsonMessage = new HashMap<>();
        jsonMessage.put("Message from DB",result);
        return jsonMessage;
    }
}
